
# array basics
import numpy as np
x = np.array(((1, 2, 3), (4, 5, 6)))
x.size # total number of elements
x.ndim # number of dimensions
x.shape # number of elements in each dimension
x[1,2] # first index is the rows, then the column
x[1] # give me '1' row
x[1][2]
x.dtype

# basic methods
x = np.array([0, np.pi/4, np.pi/2])
np.sin(x)
np.dot([2, 2, 2], [2, 2, 2])

# array slicing
x = np.array((1, 2, 3, 4, 5, 6))
x[2]
x[2:5]
x[2:-1]
x[:5]
x[:5:2] = 10
x

# array copying
a = np.array((1,2,3,4))
b = a
b is a
c = a.view()
c.shape = 2,2
c[1,1]=10
c
a
d = a.copy()

# the end
