import game_of_life as gof
import numpy as np

def test_idx_neighbors():
    a = np.zeros((3,3))
    a[1,1] = 1
    for i in range(3):
        for j in range(3):
            neighbor_num = gof.idx_neigbors(a, i, j)
            if i == 1 and j == 1:
                assert(neighbor_num == 0)
            else:
                assert(neighbor_num == 1)

def test_update():
    a = np.zeros((5,5))
    a[2,1:4] = 1
    gof.update(a)
    up_a_answer = np.zeros_like(a)
    up_a_answer[1:4, 2] = 1
    assert(np.all(a == up_a_answer))

# def test_neighbors():
#     '''Test that with center alive, all cells but center have neighbors'''
#     a = np.zeros((3,3))
#     a[1, 1] = 1
#     b = np.ones((3,3))
#     b[1, 1] = 0
#     n_a = gof.neighbors(a)
#     assert(np.all(b == n_a))


# def test_if_alive():
#     '''Test taht only live cell is in center'''
#     a = np.zeros((3,3))
#     a[1, 1] = 1
#     w_a = gof.if_alive(a)
#     w_a_answer = np.zeros((3,3), dtype=bool)
#     w_a_answer[1,1] = True
#     assert(np.all(w_a == w_a_answer))
#     assert(np.all(a[np.where(w_a)] == 1))

# def test_if_dead():
#     '''Test that only dead cell is in center'''
#     a = np.ones((3,3))
#     a[1,1] = 0
#     w_a = gof.if_dead(a)
#     w_a_answer = np.zeros((3,3), dtype=bool)
#     w_a_answer[1,1] = True
#     assert( np.all(w_a == w_a_answer))
#     assert( a[np.where(w_a)] == 0 )

# def test_where_let_die():
#     '''If not right # of neighbors, let 1 values go to 0'''
#     a = np.zeros((5,5))
#     a[2,1:4] = 1
#     ld_a = gof.where_live_and_let_die(a)
#     assert(ld_a == ((2,2)))
#     a[1,2] = 1
#     a[3,2] = 1
#     ld_a = gof.where_live_and_let_die(a)
#     assert(ld_a == ((1,2), (3,2)))
    

# def test_stay_alive():
#     a = np.zeros((5,5))
#     a[2,1:5] = 1
#     n = gof.neighbors(a)


