import numpy as np
#import matplotlib.pyplot as plt

def idx_neigbors(mat, i, j):
    ni, nj = mat.shape
    return (mat[i-1, j-1] +
            mat[i-1, j ] +
            mat[i-1, (j+1) % nj] +
            mat[i, j-1] +
            mat[i, (j+1)%nj] +
            mat[(i+1)%ni, j-1] +
            mat[(i+1)%ni, j] +
            mat[(i+1)%ni, (j+1)%nj])

def update(mat):
    for i in range(mat.shape[0]):
        for j in range(mat.shape[1]):
            neighbor_num = idx_neigbors(mat, i, j)
            if mat[i,j] == 1:
                if not (neighbor_num == 2 or neighbor_num == 3):
                    mat[i,j] == 0
            else:
                if neighbor_num == 3:
                    mat[i,j] == 1

def neighbors(mat):
    n_mat = np.zeros_like(mat)
    for x in range(-1,2):
        for y in range(-1,2):
            if x == 0 and y == 0:
                continue
            n_mat += np.roll(np.roll(mat, x, axis=0), y, axis=1)
    return n_mat


def if_alive(mat):
    return mat == 1

def if_dead(mat):
    return mat == 0

def where_live_and_let_die(mat):
    n_mat = neighbors(mat)
    alive_idx = if_alive(mat)
    return np.where(np.logical_and(
        if_alive(mat),
        np.logical_or(n_mat == 2, n_mat == 3)))

def where_live_and_let_live(mat):
    n_mat = neighbors(mat)
    alive_idx = where_alive(mat)
    return np.where(np.logical_and(n_mat[alive_idx] == 2,
                                   n_mat[alive_idx] == 3))



