#!/usr/bin/env python

from __future__ import print_function
import sys

from temp_convert import ctof, ftoc

if __name__ == '__main__':
    if len(sys.argv) != 3:
        print("Usage: {0} temp f|c".format(sys.argv[0]))
        sys.exit(1)
    temp = float(sys.argv[1])
    fc = sys.argv[2].lower()
    if fc == 'f':
        print('{0:.2f} Fahrenheit = {1:.2f} Celcius'.format(temp, ftoc(temp)))
    elif fc == 'c':
        print('{0:.2f} Celcius = {1:.2f} Fahrenheit'.format(temp, ctof(temp)))
    else:
        print("Usage: {0} temp f|c".format(sys.argv[0]))
