#!/usr/bin/env python

import sys

from temp_convert import ctof, ftoc

def usage_message():
    print("Usage: {0} temp f|c".format(sys.argv[0]))

if __name__ == '__main__':
    if len(sys.argv) != 3:
        usage_message()
        sys.exit(1)
    temp = float(sys.argv[1])
    fc = sys.argv[2].lower()
    if fc == 'f':
        print('{0:.2f} Fahrenheit = {1:.2f} Celsius'.format(temp, ftoc(temp)))
    elif fc == 'c':
        print('{0:.2f} Celsius = {1:.2f} Fahrenheit'.format(temp, ctof(temp)))
    else:
        usage_message()
